use actix_web::http::{StatusCode};
use actix_web::web::{ServiceConfig, resource as r, get, post};
use actix_web::{HttpRequest, HttpResponse, Result, Error};
use bytes::Bytes;

use crate::actix_test::models::user_info::UserInfo;

/// route config
pub fn config(cfg: &mut ServiceConfig) {
    cfg
        .service(
            r("/")
                .route(get().to(index))
                .route(post().to(index_post))
        );
}

/// index page
async fn index(req: HttpRequest) -> Result<HttpResponse> {
    println!("{:?}", req);

    // response
    Ok(HttpResponse::build(StatusCode::OK)
        .content_type("text/html; charset=utf-8")
        .body(include_str!("../../../static/index.html")))
}

/// http post example
//async fn index_post(item: web::Json<UserInfo>) -> Result<HttpResponse, Error> { // need json Content-Type
async fn index_post(body: Bytes) -> Result<HttpResponse, Error> {
    //let obj = item.0;
    let obj = serde_json::from_slice::<UserInfo>(&body)?;
    println!("model: {:?}", &obj);
    Ok(HttpResponse::Ok().json(obj)) // <- send response
}