use actix_web::web::{ServiceConfig, scope, resource as r, get};

/// route config
pub fn config(cfg: &mut ServiceConfig) {
    cfg
        .service(
            scope("/test")
                .service(r("/imgood").route(get().to(im_good)))
        );
}

/// health check
// Actix web request param binding:
// request object: req: HttpRequest    println!("{:?}", req) req.headers().get("headerKey")
// path: web::Path<(param0Type, paramNType)>    path.0 path.N
// query: web::Query<HashMap<String, String>>    query.get("queryStringOrFromParamKey")
// item: web::Json<MyObj>    item.0
// body: bytes::Bytes
// mut payload: web::Payload
async fn im_good() -> String {
    format!("{{\"status\":0,\"msg\":\"success\"}}")
}