// [dependencies]
// image = "0.23.1"
// qrcode = "0.12.0"
// base64 = "0.12.0"
// leptess = "0.8.1" # for OCR

use qrcode::{QrCode, EcLevel};

pub fn test(min: i32, max: i32) {
    // QRCode
    let arr_first = [
        '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
        'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
    ];
    let arr_domain = [
        '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.', '-',
        'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
        'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'
    ];
    for size in min..max { // 如英文域名长度2到46个字符，则min=2，max=47
        for c in arr_first.iter() {
            walk(format!("{}", c).as_str(), size - 1, &arr_domain)
        }
    }

    // OCR
    // let mut lt = leptess::LepTess::new(None, "chi_sim").unwrap();
    // lt.set_image("./tmp/qrcode.png");
    // println!("OCR result:{}", lt.get_utf8_text().unwrap());
}

fn walk(s: &str, level: i32, arr: &[char]) {
    for c in arr.iter() {
        let new_s = format!("{}{}", s, c);
        if level == 0 {
            let data_http = format!("http://{}.com", new_s);
            qr_code_gen(data_http.as_str());

            let data_https = format!("https://{}.com", new_s);
            qr_code_gen(data_https.as_str());
        } else {
            walk(new_s.as_str(), level - 1, arr)
        }
    }
}

pub fn qr_code_gen(data: &str) {
    println!("QR code for {}", data);

    let out_path = "./tmp";
    let name = base64::encode(data);

    let code_m = QrCode::new(data).unwrap();
    let image_m = code_m.render::<image::Luma<u8>>().build();
    image_m.save(format!("{}/{}_M.png", out_path, name)).unwrap();

    let code_l = QrCode::with_error_correction_level(data, EcLevel::L).unwrap();
    let image_l = code_l.render::<image::Luma<u8>>().build();
    image_l.save(format!("{}/{}_L.png", out_path, name)).unwrap();

    let code_q = QrCode::with_error_correction_level(data, EcLevel::Q).unwrap();
    let image_q = code_q.render::<image::Luma<u8>>().build();
    image_q.save(format!("{}/{}_Q.png", out_path, name)).unwrap();

    let code_h = QrCode::with_error_correction_level(data, EcLevel::H).unwrap();
    let image_h = code_h.render::<image::Luma<u8>>().build();
    image_h.save(format!("{}/{}_H.png", out_path, name)).unwrap();
}