// [dependencies]
// chrono = "0.4.11"

mod keygen;

use std::thread;
use std::sync::mpsc;
use std::collections::HashMap;
use chrono::prelude::*;

pub fn test() {
    let id = keygen::next_id();
    println!("key from keygen:{}", id);
    println!();
    test_next_id();
}

fn test_next_id() {
    let id_size = 100000;

    let start_time = Utc::now().timestamp_nanos();
    let (tx, rx) = mpsc::channel();


    for _ in 0..id_size {
        let tx = tx.clone();
        thread::spawn(move || {
            let id = keygen::next_id();
            tx.send(id).unwrap()
        });
    };

    let (tx2, rx2) = mpsc::channel();
    let tx2 = tx2.clone();
    let handle = thread::spawn(move || {
        let mut m: HashMap<u64, i32> = HashMap::new();
        let mut i = id_size;
        loop {
            let id = rx.recv().unwrap();
            //let mut wrap = wrap.lock().unwrap();
            if m.contains_key(&id) {
                let v = *(m.get_mut(&id).unwrap());
                m.insert(id, v + 1);
            } else {
                m.insert(id, 1);
            }
            i -= 1;
            if i == 0 {
                break;
            }
        }
        tx2.send(m).unwrap();
    });

    handle.join().expect("The thread being joined has panicked");

    let m = rx2.recv().unwrap();

    let end_time = Utc::now().timestamp_nanos();
    let used_time = end_time - start_time;
    println!("Id size: {}\nTotal seconds:{}\nAvg nanos per id:{}", m.len(), used_time / 1000000000, (used_time as i64) / (id_size as i64));

    let mut bad_size = 0;
    for (_, v) in m.iter() {
        if *v > 1 {
            bad_size += 1;
        }
    }

    if bad_size > 0 {
        println!("Not good")
    }
}